summaryrefslogtreecommitdiff
path: root/packages/altboot/files/nslu2le/altboot-handlers/05-USB-Storage
diff options
context:
space:
mode:
authorMatthias Hentges <oe@hentges.net>2007-03-27 22:22:45 +0000
committerMatthias Hentges <oe@hentges.net>2007-03-27 22:22:45 +0000
commite55d052b8fe7279f2fc23944fd5dd75e743d1a4b (patch)
treeb84cfe224db5d5956437b9efcd73271d60961174 /packages/altboot/files/nslu2le/altboot-handlers/05-USB-Storage
parent1944b83357f5afec7e0560124ddfcf81b8fc07a5 (diff)
altboot: Update to latest version
Diffstat (limited to 'packages/altboot/files/nslu2le/altboot-handlers/05-USB-Storage')
-rw-r--r--packages/altboot/files/nslu2le/altboot-handlers/05-USB-Storage90
1 files changed, 90 insertions, 0 deletions
diff --git a/packages/altboot/files/nslu2le/altboot-handlers/05-USB-Storage b/packages/altboot/files/nslu2le/altboot-handlers/05-USB-Storage
new file mode 100644
index 0000000000..50d35ed542
--- /dev/null
+++ b/packages/altboot/files/nslu2le/altboot-handlers/05-USB-Storage
@@ -0,0 +1,90 @@
+#!/bin/sh
+# NOTE: Ported to altboot by CoreDump <oe@hentges.net>
+# Based on the original turnup helper script.
+#
+# All parts by Matthias 'CoreDump' Hentges are hereby placed
+# under the terms of the GPL
+#
+# boot from the hard disk partition "$1" (which
+# must be given) using options from the rest of
+# the command line.
+#
+
+M_TITLE="Boot USB Storage"
+test "$USB_HOST_AVAILABLE" = "yes" || exit 0
+
+run_module() {
+ x=x
+}
+
+case "$1" in
+title) echo "$M_TITLE" ; exit 0 ;;
+run) run_module "$2";;
+esac
+
+nslu2_feeback heartbeat
+
+bootdev_data="$*"
+bootdev_mode="`echo "$bootdev_data" | awk '{print $1}'`"
+bootdev_name="`echo "$bootdev_data" | awk '{print $2}'`"
+bootdev_uuid="`echo "$bootdev_data" | awk '{print $3}'`"
+
+
+# Use the standard init path (see /etc/init.d/rcS)
+export PATH=/sbin:/bin:/usr/sbin:/usr/bin
+#
+# Load the helper functions
+. /etc/default/functions
+. /etc/default/modulefunctions
+#
+leds boot system
+#
+if test -n "$1"
+then
+ device="$bootdev_name"
+ UUID="$bootdev_uuid"
+
+ shift
+ # proc is needed for UUID mount and module load
+ mount -t proc proc /proc
+ # load USB & SCSI storage modules (/proc required!)
+ echo "boot: loading modules required for disk boot"
+ loaddiskmods
+ # waiting for disk (FIXME)
+ sleep=6
+ test "$sleep" -gt 0 && sleep "$sleep"
+ #
+ # fire the boot
+ echo "boot: rootfs: mount $* $device [$UUID]"
+ #
+ # Mount read-write because before exec'ing init
+ # If a UUID is given (in the environment) this
+ # is used in preference to the device, but if
+ # the UUID mount fails a standard device mount
+ # is attempted.
+ if test -n "$UUID" &&
+ mount "$@" -U "$UUID" /mnt ||
+ mount "$@" "$device" /mnt
+ then
+ # checkmount checks for sh, chroot, init
+ # and /mnt (i.e. /mnt/mnt in this case)
+ if checkmount /mnt
+ then
+ # pivot to /initrd if available, else /mnt
+ cd /
+ if test -d /mnt/initrd
+ then
+ swivel mnt initrd
+ else
+ swivel mnt mnt
+ fi
+ # swivel failed
+ fi
+ # Failure: unmount the partition
+ umount /mnt
+ fi
+fi
+
+# fallback - use the flash boot
+nslu2_feeback failure
+exec /boot/flash